{$C-}
program Aedi;
const
  Vers = '2.32';
  DlyFactor = 100;

type
  anystring = string[80];
  TabRange = 1..80;
  State = (Blank,Zero,One);
  Options = (Right,Left,Stop);
  StateStr = array[State] of Char;
  OptStr = array[Options] of Char;
  Board = 1..3;
  Command = record
          NewState : State;
          Option : Options;
          NewBoard : Board;
        end;
  Cmd = string[4];

const
  StateRep : StateStr = ('B','0','1');
  TabletRep : StateStr = (' ','0','1');
  OptRep : OptStr = ('R','L','S');

var
  Instructions : array[Board,State] of Command;
  Tablet : array[TabRange] of State;
  TabPos : 0..81;
  CurrBoard : Board;
  Dly : integer;
  Again : char;
  Same, Err, Exit : boolean;
  dummy : char;
  Move, LPform : integer;
{.HE The Election of Aedi - Utility Subroutines                      Page #}
{.PA}
function Inkey : boolean;
begin
  Inkey:=Keypressed;
  If KeyPressed then
     read(Kbd,dummy)
  end;

function Upper(Xarg : anystring) : anystring;
var
  Index : integer;

begin
  for Index:=1 to length(Xarg) do
    Xarg[Index]:=Upcase(Xarg[Index]);
  Upper:=Xarg;
  end;

procedure Space(Num : integer);
begin
  write(' ':Num-1)
  end;

procedure CenterA(S: AnyString);
begin
  Space((80-Length(S)) div 2)
end;

procedure Center(S : AnyString);
begin
   CenterA(S);
   writeln(S)
   end;

procedure ClrFld(Row,Col,Num : integer);
begin
  GotoXY(Row,Col);
  Space(Num);
  GotoXY(Row,Col)
  end;
{.HE The Election of Aedi - Main Subroutines                         Page #}
{.PA}
procedure WriteCmd(Xarg : Command);
begin
  with Xarg do begin
    If Option=Stop then
      Write('Stop ')
    else begin
      Write(StateRep[NewState],'-',OptRep[Option],'-',NewBoard)
      end
    end
  end;

procedure ConvCmd(Xarg : Cmd;
                  var Conv : Command;
                  var Err : boolean);
var
  BoardP, ErrCode : integer;

begin
  Err:=False;
  Xarg:=Upper(Xarg);
  with Conv do begin
    If Xarg='STOP' then
      Conv.Option:=Stop
    else begin
      Case Xarg[1] of
        'B' : NewState:=Blank;
        '0' : NewState:=Zero;
        '1' : NewState:=One;
      else
        err:=True
        end; {case}
      Case Xarg[2] of
        'R' : Option:=Right;
        'L' : Option:=Left;
      else
        err:=True
        end;
      Val(Xarg[3],BoardP,ErrCode);
      If (ErrCode=0) and (BoardP in [1..3]) then
        NewBoard:=BoardP
      else
        err:=True
      end; {if}
    If err then
      Option:=Stop
    end {with}
  end; {ConvCmd}

procedure UpdatTab(NewState : State);
begin
   Tablet[TabPos]:=NewState;
   GotoXY(TabPos,22);
   Write(TabletRep[NewState]);
   end;

procedure InitTab;
var
  Index : TabRange;

begin
  For Index:=1 to 80 do
    Tablet[Index]:=Blank;
  end;

procedure PRSBoards;
var
  Index : Board;
  Index2 : State;
begin
  For Index:=1 to 3 do
    For Index2:=Blank to One do
      Instructions[Index,Index2].Option:=Stop
  end;

procedure InitScr;
const
  DownRt = ^J^H^H^H;

var
  Index : integer;

begin
  ClrScr;
  For Index:=0 to 7 do begin
    GotoXY(Index*10,23);
    write(Index,^J^H,'0123456789');
    end;
  for Index:=1 to 3 do begin
     GotoXY(Index*20-12,3);
     write('Set ',Index);
     GotoXY((Index-1)*20+1,4);
     write('B |',DownRt,'0 |',DownRt,'1 |')
     end;
  GotoXY(1,8);
  write('Memory Address:');
  GotoXY(25,8);
  write('Move #');
  GotoXY(40,8);
  write('Program Counter:');
  GotoXY(1,10);
  write('Instruction Register:');
  end;

function NumberOfOnes : integer;
var
  Index, Max, Num : integer;

begin
  Max:=0;
  Num:=0;
  For Index:=1 to 80 do begin
    If Tablet[Index]=One then
       Num:=Num+1
    else begin
       If Num>Max then
          Max:=Num;
       Num:=0;
       end {else}
    end; {For}
  NumberofOnes:=Max
  end; {Function}
{.HE The Election of Aedi - Main SubPrograms                         Page #}
{.PA}
procedure Header;
var
  Flash : boolean;

begin
  ClrScr;
  GotoXY(1,12);
  Center('Version '+Vers);
  Center('By Theodore Ts''o');
  writeln;
  Center('Hit any key to Continue');
  Flash:=False;
  Repeat;
    GotoXY(1,10);
    CenterA('The Aedian Elections');
    Flash:=not Flash;
    If Flash then
       LowVideo;
    write('The Aedian Elections');
    NormVideo;
    Delay(100)
    Until Inkey
  end;

procedure PRS;          {Preset System}
begin
  Header;
  PRSBoards;
  Same:=False
  end;

procedure Init;
begin
  TabPos:=40;
  CurrBoard:=1;
  LPform:=0;
  Move:=1;
  Err:=false;
  Exit:=false;
  InitTab;
  InitScr
  end;

procedure GetBoards;
var
  Ins : Cmd;
  Err : Boolean;
  Row,Col : integer;
  Index : Board;
  Index2 : State;
  Edit : char;

begin
  Repeat
    For Index:=1 to 3 do
      For Index2:=Blank to One do begin
        Row:=(Index-1)*20+5;
        Col:=ord(Index2)+4;
        If not Same then
          repeat
            ClrFld(Row,Col,17);
            Ins:='';
            readln(Ins);
            if Ins='' then
               err:=false
            else
               ConvCmd(Ins,Instructions[Index,Index2],Err);
            Until not err;
        ClrFld(Row,Col,17);
        WriteCmd(Instructions[Index,Index2])
        end;
    GotoXY(40,10);
    Write('Edit (Y/N)? ');
    Read(Kbd,Edit);
    GotoXY(40,10);
    ClrEol;
    Same:=false;
    Until not (Edit in ['Y','y'])
  end;

procedure GetParam(var Dly : integer);
var
  DlyStr : string[10];
  errcode : integer;

begin
  Dly:=0;
  GotoXY(40,10);
  repeat
    write('DelayFactor? ');
    readln(DlyStr);
    GotoXY(40,10);
    ClrEol;
    val(DlyStr,Dly,errcode);
    until errcode=0;
  end;

procedure PrintStatus;
var
  Ins : Command;

begin
  GotoXY(17,8);
  write(TabPos,' ');
  GotoXY(31,8);
  write(Move);
  GotoXY(57,8);
  write(CurrBoard);
  Write(StateRep[Tablet[TabPos]],' ');
  GotoXY(23,10);
  Ins:=Instructions[CurrBoard,Tablet[TabPos]];
  WriteCmd(Ins);
  If Ins.Option=Stop then begin
    GotoXY(40,10);
    write('Number of Ones: ',NumberofOnes)
    end
  end;

procedure DoCmd(DeCommand : Command; var Exit,Err : boolean);
begin
  with DeCommand do begin
    If Option=Stop then
      exit:=True
    else begin
      UpdatTab(NewState);
      case Option of
        Right : TabPos:=Tabpos+1;
        Left  : TabPos:=Tabpos-1;
        end;
      If not(TabPos in [1..80]) then
         Err:=True;
      CurrBoard:=NewBoard
      end
    end;
  Move:=Move+1
  end;

procedure XmitLP;
var
  Index : integer;
  Line : string[82];

procedure Xmit(X : integer);
begin
   GotoXY(1,X);
   write(#27,';');
   readln(Kbd,Line);
   writeln(Lst,Line)
   end;

begin
  For Index:=3 to 11 do
    Xmit(Index);
  For Index:=21 to 24 do
    Xmit(Index);
  For Index:=1 to 3 do
    writeln(Lst);
  LPform:=LPform+1;
  If LPform mod 4=0 then
    writeln(Lst,^L);
  end;

procedure Wait(Xarg : integer);
begin
  Exit:=Inkey;
  if not Exit then
    If Xarg>=0 then
      Delay(Xarg*DlyFactor)
    else if Xarg=-99 then
      XmitLP
    else begin
      write(^G);
      repeat until Inkey;
      If upcase(dummy)='P' then
         XmitLP;
      If dummy=^C then
         Exit:=true;
      end
  end;

{******************************Here begynth the maine programme*********}
begin
  PRS;
  repeat
    Init;
    GetBoards;
    GetParam(Dly);
    repeat
       PrintStatus;
       Wait(Dly);
       DoCmd(Instructions[CurrBoard,Tablet[TabPos]],Exit,Err);
       If Err then begin
          GotoXY(40,10);
          write(^G'Fatal Error - infinite series')
          end;
       until Exit or Err;
    repeat
      GotoXY(1,14);
      write('(E)xit, (P)rint screen, (R)epeat, or (C)ontinue<C>? ');
      Again:='C';
      read(Kbd,Again);
      Again:=Upcase(Again);
      if Again='P' then
         XmitLP;
      until Again<>'P';
    Same:=Again='R';
    until Again='E';
  ClrScr;
end.
