{-----------------------------------------------------------------}
{                                                                 }
{      Taxman - A number picking game                             }
{                                                                 }
{      Written by Theodore Ts'o at one sitting, without any       }
{      planning.  (i.e., This was hacked out.)  AND NEITHER       }
{-----------------------------------------------------------------}
program TaxMan;
const
  MaxNum = 100;

type
  TaxSet = set of 1..MaxNum;

var
  Board, Player, TaxMan, TaxResult : TaxSet;
  Num,I,TopNum : integer;
  ch : char;

procedure ClrEos;
begin
  write(^[,'J')
  end;

function Sum(ASet : TaxSet) : integer;
var
  S,Index : integer;

begin
  S:=0;
  For Index:=1 to TopNum do
    If Index in ASet then
      S:=S+Index;
  Sum:=S;
  end;

procedure PrintSet(ASet : TaxSet);
var
  I : integer;

begin
  For I:=1 to TopNum do begin
    If I in Aset then
      write(I:5)
    else
      write('':5);
    If I mod 15 = 0 then
      writeln;
    end
  end;

procedure WriteSet(ASet : TaxSet);
var
  I,P : integer;

begin
  P:=0;
  For I:=1 to TopNum do
    If I in ASet then begin
      P:=P+1;
      write(I:5);
      If P mod 15 = 0 then
        writeln;
      end
  end;

procedure GetTax(var TaxResult : TaxSet; Num : integer);
var
  I : integer;

begin
  TaxResult:=[];
  For I:=Num-1 downto 1 do
    If (I in Board) and (Num mod I=0) then
      TaxResult:=TaxResult+[I];
  end;

procedure ShowResult;
begin
  GotoXY(1,13);
  ClrEos;
  if Num=0 then
    writeln('You get:')
  else
    writeln('You get: ',Num);
  writeln;
  writeln('Taxman gets:');
  writeln;
  writeset(TaxResult);
  writeln;
  writeln;
  writeln('Your score: ',Sum(Player));
  writeln('Taxman''s Score: ',Sum(TaxMan));
  end;

function CheckEnd : boolean;
var
  Done : boolean;
  TaxResult : TaxSet;
  I,J : integer;

begin
  Done:=true;
  I:=0;
  while Done and (I<TopNum) do begin
    I:=I+1;
    J:=I;
    If I in Board then
      While Done and (J>1) do begin
        J:=J-1;
        Done:=not ((J in Board) and (I mod J=0));
        end
    end;
  CheckEnd:=Done;
  end;

procedure Move;
label
  Exit;

var
  Legal : boolean;

begin
  repeat
    GotoXY(1,23);
    ClrEol;
    write('Pick a number: ');
    readln(Num);
    Legal:=(Num in Board);
    If Legal then begin
      GetTax(TaxResult,Num);
      If TaxResult=[] then
        Legal:=False
      end;
    If Num=0 then
      Goto Exit;
    until Legal;
  TaxMan:=TaxMan+TaxResult;
  Player:=Player+[Num];
  Board:=Board-[Num]-TaxResult;
  GotoXY(1,3);
  PrintSet(Board);
  ShowResult;
Exit:
  end;

begin
  ClrScr;
  writeln('':32,'The TAXMAN cometh');
  gotoxy(1,1);
  for I:=1 to 8 do begin
    delay(200);
    InsLine;
    end;
  repeat
    GotoXY(1,20);
    write('How many numbers to want to play with: ');
    readln(TopNum);
    If TopNum=0 then
      Halt;
    until TopNum<=MaxNum;
  Player:=[];
  TaxMan:=[];
  Board:=[1..TopNum];
  ClrScr;
  writeln('The playing board:');
  writeln;
  PrintSet(Board);
  repeat
    Move;
    until CheckEnd or (Num=0);
  GotoXY(1,23);
  write('End of game.  Hit any key to continue: ');
  read(kbd,ch);
  TaxMan:=TaxMan+Board;
  TaxResult:=Board;
  Num:=0;
  GotoXY(1,3);
  PrintSet([]);
  ShowResult
  end.
